@echo off
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION
::<---------------------------------------------------------------------
::<MakeBS.cmd Batch script to create a bootsector from current one
::<invoking NTLDR and make it invoke another loader such as SETUPLDR.BIN
::<(FAT16 and FAT32 partitions ONLY) Win2k/XP/2003 NO Win9.x/Me
::<It can optionally add a line invoking this bootsector in BOOT.INI 
::<IF a BOOT.INI is already present in the same partition
::<Release 0.01 ALPHA 07/June/2007
::<This script uses the functions of the DS File Ops Kit (DSFOK):
::<http://members.ozemail.com.au/~nulifetv/freezip/freeware/
::<This script by Jacopo Lazzari
::<http://home.graffiti.net/jaclaz:graffiti.net/
::<---------------------------------------------------------------------
::<
::<
IF %1.==. goto :HELP
IF NOT "%1."=="/?." goto :1STCHECK

:HELP
::<Command line usage:
::<MakeBS Driveletter:\NewLoader /A [BootIniEntryText]
::<Where:
::<Driveletter can be any letter assigned to a partition from C: to Z:
::<
::<Newloader is the filename of the loader, it must already exist on root
::<of the given Drive
::<
::<The output file will have the first part of the 8(+3) DOS given
::<name for NewLoader with the .BS extension
::< 
::<If you add the /A switch, the program will attempt adding
::<an entry to the BOOT.INI file on the given partition (if any)
::< 
::<If you add the [BootIniEntryText] as parameter, the program will use the 
::<supplied string instead of the default "Load Newloader bootsector" 
::< 
::<The supplied string MUST be enclosed in double quotes!
::<
::<A copy of Original Bootsector is made on root of Drive as "BackupBS.ori"
::< 
::<Examples:
::<MakeBS C:\SETUPLDR.BIN
::<Will create a file C:\SETUPLDR.BS and a file C:\BackupBS.ori
::< 
::<MakeBS C:\MYLDR /A
::<Will create a file C:\MYLDR.BS,a file C:\BackupBS.ori and add an entry in 
::<BOOT.INI as this: C:\MYLDR.BS="Load MYLDR bootsector"
::< 
::<MakeBS C:\ANOTHER.LDR /A "Start custom bootsector"
::<Will create a file C:\ANOTHER.BS AND add an entry in BOOT.INI as this:
::<C:\ANOTHER.BS="Start custom bootsector"
::<---------------------------------------------------------------------
CLS
TYPE MakeBS.cmd | Find /V "TYPE MakeBS.cmd"| Find "::<" | MORE
PAUSE
GOTO :EOF

:1STCHECK
SET WorkDrive=%~d0
SET WorkDir=%~dp0
SET Drive=%~d1
SET NewLoader=%~nx1
SET Switch=none
SET Entry="Load %Newloader% bootsector"
IF NOT %2.==. SET Switch=%2
IF NOT %3.==. SET Entry=%3
%~d0
cd "%~dp0"

REM IF NOT EXIST %Drive%\%Newloader% GOTO :ERROR1 %Drive%\%Newloader%
IF NOT EXIST dsfo.exe GOTO :ERROR1 dsfo.exe
IF NOT %Switch%==none IF NOT "%Switch%"=="/A" GOTO :ERROR2




SET Overwrite=NO
dsfo \\.\%Drive% 0 512 TempBSec.$$$ >nul
IF EXIST %Drive%\BackupBS.ori (
ECHO A file named BackupBS.ori already exists on drive %Drive%
ECHO Are you sure you want to overwrite it?
SET /P Overwrite=[Please enter YES in capital letters to confirm]
SET Overwrite
IF NOT !Overwrite!==YES GOTO :ERROR5
)

copy /B TempBSec.$$$ %Drive%\BackupBS.ori >nul

ECHO....
ECHO Current bootsector of drive %drive%\ backed up to %Drive%\BackupBS.ori
ECHO....

SET FAT=0
SET NTLDR=0

CALL :CheckBS 54 5 0 5 FAT FAT16
IF %FAT%.==FAT16. CALL :CheckBS 417 5 10 5 LDR NTLDR
IF %NTLDR%.==417. GOTO :FATOK

CALL :CheckBS 82 5 5 5 FAT FAT32
IF %FAT%.==FAT32. CALL :CheckBS 368 5 10 5 LDR NTLDR
IF %NTLDR%.==368. GOTO :FATOK

ECHO "%LDR%" string NOT found in drive %drive% bootsector

GOTO :Error3
:FATOK
ECHO Current bootsector appears to be %FAT%, "%LDR%" string found at offset %NTLDR%.
ECHO ...

:: Capitalize
:: This routine has been published by Frank-Peter Schultze
:: http://www.fpschultze.de/smartfaq+faq.faqid+262.htm
:: and slightly simplified by me

Set s=%NewLoader%

For %%A In (
  aA bB cC dD eE fF gG hH iI
  jJ kK lL mM nN oO pP qQ rR
  sS tT uU vV wW xX yY zZ
) Do Call :UCase %%A

Call :NewLoaderSplit %s%
IF NOT %NewLoaderExt%.==. Set NewloaderExt=%NewloaderExt:.=%
IF %NewLoaderExt%.==. (SET /A MaxChar=11) ELSE (SET /A MaxChar=8)

Set BSName=%NewLoaderName%

SET toparse=%NewLoaderName%
SET /A counter=0
Call :Parseloop
SET NewLoaderName=%toparse%

IF %NewLoaderExt%.==. SET NewLoaderName=%NewLoaderName%   &GOTO :Write
SET toparse=%NewLoaderExt%
SET /A counter=0
Call :Parseloop
SET NewLoaderExt=%toparse%


:Write
ECHO %NewLoaderName%%NewLoaderExt%>TempName.$$$
dsfo TempBSec.$$$ 0 %NTLDR% TempHead.$$$>nul
dsfo TempName.$$$ 0 11 Temp_Ldr.$$$>nul
SET /A tail=%NTLDR% + 11
dsfo TempBSec.$$$ %tail% 0 TempTail.$$$>nul

copy /b TempHead.$$$+Temp_Ldr.$$$+TempTail.$$$ %Drive%\%BSName%.bs >nul
IF %ERRORLEVEL%==0 (
ECHO ...
ECHO New bootsector %Drive%\%BSName%.bs created succesfully
ECHO ...
) ELSE (
GOTO :Error4
)


IF "%Switch%"=="/A" (
SET Entry=C:\%BSName%.bs=%Entry%
CALL :attribs %drive%\boot.ini
Find "C:\%BSName%.bs" %drive%\boot.ini>nul
IF !ERRORLEVEL!==0 ECHO Entry C:\%BSName%.bs already found, %Drive%\BOOT.INI NOT updated.&GOTO :NoAddEntry
ECHO !Entry! >> %drive%\boot.ini
ECHO !Entry! added to %Drive%\BOOT.INI
:NoAddEntry
ATTRIB !switches! %drive%\boot.ini>nul
)

For %%A in ( Name BSec Head _Ldr Tail File ) DO IF EXIST Temp%%A.$$$ DEL Temp%%A.$$$


GOTO :EOF

:UCase
Set _=%1
Call Set s=%%s:%_:~0,1%=%_:~1,1%%%
Goto :EOF

:NewLoaderSplit
Set NewloaderName=%~n1
Set NewloaderExt=%~x1
Goto :EOF

:CheckBS
dsfo TempBSec.$$$ %1 %2 TempFile.$$$ >nul
FIND "%6" TempFile.$$$>nul
ECHO ...
IF %ERRORLEVEL%==0 (
Set %5=%6
SET %6=%1
) 
del TempFile.$$$
GOTO :EOF

:ParseLoop
Set /A counter=%counter%+1
Set len=!toparse:~0,%counter%!
IF NOT %len%==%toparse% goto :ParseLoop
IF NOT %counter%==%MaxChar% SET toparse=%toparse% &goto :ParseLoop
GOTO :EOF


:attribs
SET attribs=%~a1
ATTRIB -h -r -s %drive%\boot.ini
Set IsR=%attribs:~1,1%
Set IsH=%attribs:~3,1%
Set IsS=%attribs:~4,1%
For %%A in (%IsR% %IsH% %IsS%) DO IF NOT "%%A"=="-" SET Switches=%Switches% +%%A
GOTO :EOF

:ERROR1
Echo A needed file is missing
Echo File %1 is missing
pause
GOTO :HELP

:ERROR2
Echo Given parameters are wrong
Pause
GOTO :HELP

:ERROR3
Echo Program aborted! - wrong filesystem or bootsector type
pause
GOTO :EOF

:ERROR4
Echo Error! Could not write bootsector %Drive%\%BSName%.bs
Pause
GOTO :EOF

:ERROR5
Echo Batch aborted by user
Pause
GOTO :EOF



